; ---------------------------------------------------------------------
; EBook					 STF
; ---------------------------------------------------------------------
; See_also       BlackScholes bs1 greeks volsurf 
; ---------------------------------------------------------------------
; Macro          STFfda01
; ---------------------------------------------------------------------
; Description    Estimates Volasurface of ODAX 20010524, plots it and displays summary information
; ---------------------------------------------------------------------

proc()=STFfda01()
  dataD1=read("stf/STFfdaIV010524.dat")
  IVmethod="bisect"
  stepwidth=1.5*(0.01|(0.5/52))
  bandwidth=0.1|0.2
  firstXF=0.8
  lastXF=1.2
  firstMat=0
  lastMat=0.65
  metric=0
  AdjustToSurface=1
  {IVsurf,IVpoints}=volsurf(dataD1, stepwidth,firstXF,lastXF,firstMat,lastMat, metric,bandwidth,0,IVmethod)
;volsurfplot(IVSurface,IVpoints,AdjustToSurface)

  error((sum(sum(IVsurf<0)')>=1),"volsurflot: Watch out: Some of your data entries in the surface are negative!!")  
  error((sum(sum(IVpoints<0)')>=1),"volsurflot: Watch out: Some of your data entries in points are negativ!!")  
  error((cols(IVsurf)!=3),"volsurflot: surface matrix must have 3 columns")
  error((cols(IVpoints)!=3),"volsurflot: points matrix must have 3 columns")

  IVsurf=setmask(IVsurf,"surface","blue")                         ; surface
 
  if (exist("AdjustToSurface")==0)
    AdjustToSurface=1
  endif

  if (AdjustToSurface==1) 
    i=0
    l=0
    IVpoints2=matrix(1,3)
    do 
      i=i+1
      if ((IVpoints[i,1]<max(IVsurf[,1]))&&(IVpoints[i,1]>min(IVsurf[,1])))
        if ((IVpoints[i,2]<max(IVsurf[,2]))&&(IVpoints[i,2]>min(IVsurf[,2])))
          if (l==0)
            IVpoints2=IVpoints[i,]
            l=1
          else
            IVpoints2=IVpoints2|IVpoints[i,]
          endif
        endif
      endif
    until (i==rows(IVpoints))
    m =setmask(IVpoints2,"red","fillcircle","small")
    cube=max(IVsurf)|min(IVsurf)
  else
    m =setmask(IVpoints,"red","fillcircle","small")        ; original observations
    cube=max(IVpoints)|min(IVpoints)                                                                                ; Wrfelmae
  endif
 
  plot3d(3,IVsurf,m)


  dis=discrete(dataD1[,4])
  string("Maturity %7.5f",dis.xr)+string("  Num. of Observations: %7.5f",dis.yr)
  string("min volatility= %7.5f ",min(IVsurf[,3])) + string("max volatility= %7.5f ",max(IVsurf[,3]))
endp

library("finance")
STFfda01()

