; ---------------------------------------------------------------------
; EBook	         STF
; ---------------------------------------------------------------------
; See_also       fouriereval fouriertrans 
; ---------------------------------------------------------------------
; Macro          STFfda03
; ---------------------------------------------------------------------
; Description    plots the estimated vola strings using Fourier basis
; ---------------------------------------------------------------------

proc()=STFfda03()
  coef1m=read("stf/STFcoef91.dat")
  coef2m=read("stf/STFcoef92.dat")
  coef1m=paf(coef1m,!isNaN(coef1m[,1]))
  coef2m=paf(coef2m,!isNaN(coef2m[,1]))

  nbasis=9
  period=0.2
  nresol=100
  F9resol=Fouriereval(9,nresol,period)
  F9resol=F9resol[,floor(nresol/2):nresol]~F9resol[,1:floor(nresol/2)]; starts with k=0.9 and not 1
  liner=#(1:nresol)'
  setsize(1000,500)
  axesoff()
  IVstrings=createdisplay(1,2)
;grfour1=grpcp(coef1m*(F9resol),1)
  x=coef1m*(F9resol)
  col=1

  i  = 0
  n  = rows(x)
  p  = cols(x)  
  while (i.<p)
    i = i+1
    if (i.=1)
      pp = i.*matrix(n)~x[,i]
    else
      pp = pp|(i.*matrix(n)~x[,i])
    endif
  endo
  lt = (1:n)+trans(grid(0, n, p))
  setmaskp (pp, 0, 0, 0)
  setmaskl (pp, lt, col, 1, 2)
  grfour1=pp
;grfour2=grpcp(coef2m*(F9resol),1)

  x=coef2m*(F9resol)
  col=1

  i  = 0
  n  = rows(x)
  p  = cols(x)  
  while (i.<p)
    i = i+1
    if (i.=1)
      pp = i.*matrix(n)~x[,i]
    else
      pp = pp|(i.*matrix(n)~x[,i])
    endif
  endo
  lt = (1:n)+trans(grid(0, n, p))
  setmaskp (pp, 0, 0, 0)
  setmaskl (pp, lt, col, 1, 2)
  grfour2=pp

  grfour1.lsize=grfour1.lsize.*0 ; thick line
  grfour2.lsize=grfour2.lsize.*0 ; thick line

  range=#(0,nresol)
  axis1=graxes((1|101)~(0.14|0.3),"origin",0|0.14,"xticks",(25|50|75),"xtext",string("%3.2f",range[1]+0.25*(range[2]-range[1]))|"ATM"|string("%3.2f",range[1]+0.75*(range[2]-range[1])),"yticks",0.20|0.25)
  axis2=graxes((1|101)~(0.14|0.3),"origin",101|0.3,"xticks",(25|50|75),"xtext",string("%3.2f",range[1]+0.25*(range[2]-range[1]))|"ATM"|string("%3.2f",range[1]+0.75*(range[2]-range[1])),"yticks",0.20|0.25,"xtextpos",12,"ytextpos",3)
  show(IVstrings,1,1,grfour1,axis1,axis2)
  show(IVstrings,1,2,grfour2,axis1,axis2)
  setgopt(IVstrings,1,1,"title","IV-strings 1M","border",0)
  setgopt(IVstrings,1,2,"title","IV-strings 2M","border",0)
  setsize(500,500)
  axeson()
endp

library("smoother")
library("nummath")
STFfda03()



