; ---------------------------------------------------------------------
; EBook					 STF
; ---------------------------------------------------------------------
; See_also       fouriereval fouriertrans 
; ---------------------------------------------------------------------
; Macro          STFfda04
; ---------------------------------------------------------------------
; Description    plots the estimated eigenfunctions
; ---------------------------------------------------------------------

proc()=STFfda04()
  coef1m=read("stf/STFcoef91.dat")
  coef2m=read("stf/STFcoef92.dat")
  coef1m=paf(coef1m,!isNaN(coef1m[,1]))
  coef2m=paf(coef2m,!isNaN(coef2m[,1]))


  lambda=0.0
  nbasis=9
  period=0.2
  nresol=100
  F9resol=Fouriereval(9,nresol,period)
  F9resol=F9resol[,floor(nresol/2):nresol]~F9resol[,1:floor(nresol/2)]; starts with k=0.9 and not 1
  liner=#(1:nresol)'

  FDA1=FDApca(coef1m',0.2,lambda,9)
  FDA2=FDApca(coef2m',0.2,lambda,9)

  setsize(1000,500)
  harmval1=FDA1.harmcoef'*F9resol
  harmval2=FDA2.harmcoef'*F9resol

;grharm1M=grpcp(harmval1[1:3,],#(1,2,3)) ; alternative to the grpcp for nice plot
  x=harmval1[1:3,]
  col=#(1,2,3)
  art=#(1,4,6)
  thick=1
  i  = 0
  n  = rows(x)
  p  = cols(x)  
  while (i.<p)
    i = i+1
    if (i.=1)
      pp = i.*matrix(n)~x[,i]
    else
      pp = pp|(i.*matrix(n)~x[,i])
    endif
  endo
  lt = (1:n)+trans(grid(0, n, p))
  setmaskp (pp, 0, 0, 0)
  setmaskl (pp, lt, col, art, thick)
  grharm1M=pp

;grharm2M=grpcp(harmval2[1,]|harmval2[2,]|harmval2[3,],#(1,2,3))
  x=harmval2[1,]|harmval2[2,]|harmval2[3,]
  col=#(1,2,3)
  art=#(1,4,6)
  thick=1
  i  = 0
  n  = rows(x)
  p  = cols(x)  
  while (i.<p)
    i = i+1
    if (i.=1)
      pp = i.*matrix(n)~x[,i]
    else
      pp = pp|(i.*matrix(n)~x[,i])
    endif
  endo
  lt = (1:n)+trans(grid(0, n, p))
  setmaskp (pp, 0, 0, 0)
  setmaskl (pp, lt, col, art, thick)
  grharm2M=pp

  harmdi1M2M=createdisplay(1,2)
  axesoff()
  range=0.9|1.1
  axis1h=graxes((0|100)~(-6|5),"origin",0|-6,"xticks",(25|50|75),"xtext",string("%3.2f",range[1]+0.25*(range[2]-range[1]))|"ATM"|string("%3.2f",range[1]+0.75*(range[2]-range[1])),"yticks",-5|-4|-3|-2|-1|0|1|2|3|4)
  axis2h=graxes((0|100)~(-6|5),"origin",100|5,"xticks",(25|50|75),"xtext",string("%3.2f",range[1]+0.25*(range[2]-range[1]))|"ATM"|string("%3.2f",range[1]+0.75*(range[2]-range[1])),"yticks",-5|-4|-3|-2|-1|0|1|2|3|4,"xtextpos",12,"ytextpos",3)

  show(harmdi1M2M,1,1,grharm1M,axis1h,axis2h)
  show(harmdi1M2M,1,2,grharm2M,axis1h,axis2h)

  setgopt(harmdi1M2M,1,1,"title","Weight functions, 1M Group","border",0)
  setgopt(harmdi1M2M,1,2,"title","Weight functions, 2M Group","border",0)


  setsize(500,500)
  axeson()
endp

library("smoother")
library("nummath")
STFfda04()

